
``	XML Site Map Generator - Scriptol library
``	c) Denis G. Sureau
``	http://www.scriptol.com/
``  Licence GPL 2.0
     

include "path.sol"
include "libphp.sol"
include "maptools.sol"
include "mapurl.sol"


array siteList = {}  	// source of sitemap, list of pages in full URL with site address + path + filename
dict siteTime = {}		// dict of last mod date+time for each URL 

int mapname = "sitemap.xml"

void output(text t)
	siteMap.push(t)
return


// Test if page already scanned

boolean inCheckedList(text page)
	if not hasProtocol(page)
		page = createLinkFromRelative(page)
	/if
	if page in checkedList return true
return false	


// Test if page already added to list

boolean inSiteMap(text page)
	if not hasProtocol(page)
		page = createLinkFromRelative(page)
	/if
	if page in siteList return true
return false	


// Add page to list, even if not valid, to not scan it again

void addFileList(text page)
	if not hasProtocol(page)
		page = createLinkFromRelative(page)
	/if
	if page in checkedList return 
	checkedList.push(page)
return 


// Add to the site map list of all pages to be referenced


boolean addLink(text page, real lmod)

	//if not validExtension(fname) return false
	// add site url if required
	if not hasProtocol(page)
		page = Path.merge(siteURL, page)
	/if	
	
	text url = setURL(page) 	// convert to slashes
	if url in siteList return false
	
	siteList.push(url)

    if LASTMOD	
	   siteTime[url] = date(dateFormat, lmod)
	/if   
	
	display("Added link $url")
return true	




boolean isIndexable(text fullpath)
    dict tags = get_meta_tags(fullpath)
    text robots = tags['robots']
    if robots = nil return true
	if robots.findLex("noindex") <> -1 return false
	if robots.findLex("none") <> -1 return false   
return true


void buildTag(text tagname, text value)
	if value = "" return
	output("     <" + tagname + ">" + value + "</" + tagname + ">")
return

// Retrieving the previous sitemap

void readTheXMLFile(text xname)
    siteList = ""
    DOMElement x = null

	DOMDocument doc = DOMDocument("1.0")
	doc.load(xname)
    DOMNodeList dnl = element.getElementsByTagName("loc")
    if dnl.length = 0 return
    for int i in 0 -- dnl.length
        x = dnl.item(i)
        if x <> null 
            DOMText dt = x.firstChild
            siteList.push(dt.data)
            print dt.data
        /if    
    /for    
    
return


`` from the list of files
`` build now a xml file

void buildTheXMLFile()

	text name

    output("<?xml version=\"1.0\" encoding=\"UTF-8\"?>") 
    output("<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\" ")
    output("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ")
    output("xsi:schemaLocation=\"http://www.google.com/schemas/sitemap/0.84 ")
    output("http://www.google.com/schemas/sitemap/0.84/sitemap.xsd\">")
	
	for name in siteList
	
		output("  <url>")
		
		buildTag("loc", textToUTF8(name))	`` create a tag, content UTF-8 compatible

		if PRIORITY = true
			buildTag("priority", text(0.2))
		/if
	
		if (LASTMOD = true) or (LASTMODTIME = true)
			text lmod = siteTime[name]
			if lmod <> nil	let buildTag("lastmod", lmod)
		/if
		
		if FREQUENCY = true
			buildTag("changefreq", DEFAULT_FREQUENCY)
		/if	
		
		output("  </url>")
	/for	

	output("</urlset>")
	
return



`` Site Map function

int sitemap(int num, array args)
	
	int counter = 0

	if VERBOSE = true print "Creating", mapname	

    readTheXMLFile(mapname)
	siteList.sort()
    buildTheXMLFile()
	
	file x = fopen(mapname, "w")
	for text t in siteMap
		x.write(t + "\n")
	/for
	x.close()	

	logfile.store(logname)	
	display( text(siteList.size()) + " pages added to " + mapname + ", " + text(checkedList.size()) + " checked.")


return 0

